# Arrow 

Arrow is a TNC smashed together with a BLE/Bluetooth, Wi-Fi, and 2M band radio. The 2M band radio is capable of voice, AFSK, FSK, MSK, and GFSK, and is automatically retunable across the 2M band. The current functionality is listed below: 

- K.I.S.S. Style TNC 
- Bluetooth Connectivity for TNC connection (SPP Profile) 
- AX.25 support with P-Persistance CSMA 
- Frequency Flexibiltity using the Hardware configuration byte in the K.I.S.S protocol. 
- Built-in battery 3Ah w/ battery charger via micro USB connector 


![Arrow Render](http://repo.curiousmuch.org/curiousmuch/arrow-firmware/raw/master/Arrow-Render-01.png)

## Frequency Selection 
The hardware configuration byte of the K.I.S.S. protocol is used to select from a predefined table of frequencies. The K.I.S.S. protocol limits the configuration byte to...well...only a byte so a table is required. Currently, only 16 frequencies are defined to allow the 4 remaining bits to be used for future capablities. 

The table consists of mustly channels on the 2M experiential band 145.5MHz - 145.8MHz w/ 25kHz channel spacing. 

| Index | Frequency (MHz) | Comment(s) |
| ------- | ----------- | ------------ |
| 0 | 144.390 | APRS - NA |
| 1 | 145.5125 |  |
| 2 | 145.5375 |  | 
| 3 | 145.5625 |  | 
| ...| ... | ... |
| 15| 145.8625 |  |

## Demo 
You can view a quick terrible demo of Arrow being used with Linux's build into TCP/IP over AX.25 support here: https://www.youtube.com/watch?v=fh8neKRE4Ao&t=12s

In the video, I preview using the kiss-attach utility in Linux to attach to Arrow over a Bluetooth SPP connection, and ping another Arrow over AX.25. Arrow can also be used out of the box with APRSDroid, etc via the Bluetooth connection. 

## Schematic 
The current schematic is listed in this repository as a Arrow-Schematic.pdf. 

## ESP-IDF 
Version 3.3


